=== modified file 'drizzled/execute.h'
--- drizzled/execute.h	2010-12-08 02:27:22 +0000
+++ drizzled/execute.h	2010-12-08 03:38:36 +0000
@@ -41,6 +41,11 @@
     return _session;
   }
 
+  void setWait(bool arg= true)
+  {
+    wait= arg;
+  }
+
 private:
 };
 

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2010-12-08 02:27:22 +0000
+++ drizzled/sql_yacc.yy	2010-12-08 03:38:36 +0000
@@ -3254,11 +3254,16 @@
             }
             Lex->setCacheable(false);
 	  }
-        | EXECUTE_SYM '(' expr ')'
+        | EXECUTE_SYM '(' expr ')' opt_wait
           {
             List<Item> *args= new (YYSession->mem_root) List<Item>;
             args->push_back($3);
 
+            if ($5)
+            {
+              args->push_back(new (YYSession->mem_root) Item_int(1));
+            }
+
             if (! ($$= reserved_keyword_function(YYSession, "execute", args)))
             {
               DRIZZLE_YYABORT;

=== modified file 'plugin/utility_functions/execute.h'
--- plugin/utility_functions/execute.h	2010-12-08 02:27:22 +0000
+++ plugin/utility_functions/execute.h	2010-12-08 03:38:36 +0000
@@ -61,7 +61,12 @@
 
   bool check_argument_count(int n)
   {
-    return (n == 1);
+    if (n == 2)
+    {
+      execute.setWait();
+    }
+
+    return (n == 1 or n == 2);
   }
 };
 

=== added file 'plugin/utility_functions/tests/r/execute_wait.result'
--- plugin/utility_functions/tests/r/execute_wait.result	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/tests/r/execute_wait.result	2010-12-08 03:38:36 +0000
@@ -0,0 +1,23 @@
+CREATE TABLE t1 (A VARCHAR(150));
+SET @execute= "SELECT WAIT('barrier')";
+INSERT INTO t1 VALUES ("CREATE TABLE A (A INT)"), ("CREATE TABLE B (A INT)"), ("CREATE TABLE C (A INT)");
+SELECT A FROM t1 ORDER BY A;
+A
+CREATE TABLE A (A INT)
+CREATE TABLE B (A INT)
+CREATE TABLE C (A INT)
+SELECT EXECUTE(A) WAIT, 1 FROM t1;
+EXECUTE(A) WAIT	1
+1	1
+1	1
+1	1
+SELECT TABLE_NAME FROM DATA_DICTIONARY.TABLES WHERE TABLE_SCHEMA=SCHEMA() ORDER BY TABLE_NAME;
+TABLE_NAME
+A
+B
+C
+t1
+SELECT IF((COUNT(TABLE_NAME) = 3), "YES", "NO") FROM DATA_DICTIONARY.TABLES WHERE TABLE_NAME IN ("A", "B", "C") AND TABLE_SCHEMA=SCHEMA();
+IF((COUNT(TABLE_NAME) = 3), "YES", "NO")
+YES
+DROP TABLE t1;

=== added file 'plugin/utility_functions/tests/t/execute_wait.test'
--- plugin/utility_functions/tests/t/execute_wait.test	1970-01-01 00:00:00 +0000
+++ plugin/utility_functions/tests/t/execute_wait.test	2010-12-08 03:38:36 +0000
@@ -0,0 +1,9 @@
+# Lets see if we wait!
+CREATE TABLE t1 (A VARCHAR(150));
+SET @execute= "SELECT WAIT('barrier')";
+INSERT INTO t1 VALUES ("CREATE TABLE A (A INT)"), ("CREATE TABLE B (A INT)"), ("CREATE TABLE C (A INT)");
+SELECT A FROM t1 ORDER BY A;
+SELECT EXECUTE(A) WAIT, 1 FROM t1;
+SELECT TABLE_NAME FROM DATA_DICTIONARY.TABLES WHERE TABLE_SCHEMA=SCHEMA() ORDER BY TABLE_NAME;
+SELECT IF((COUNT(TABLE_NAME) = 3), "YES", "NO") FROM DATA_DICTIONARY.TABLES WHERE TABLE_NAME IN ("A", "B", "C") AND TABLE_SCHEMA=SCHEMA();
+DROP TABLE t1;

